import { defineComponent as H, useSlots as I, inject as b, provide as K, computed as x, watch as s, onUnmounted as A, openBlock as S, createElementBlock as $, renderSlot as U } from "vue";
import { D as W, u as Y, H as j, p as z, A as V, z as q, a as J } from "./resize-bus-BJO1V4ET.js";
import { $drawingManagerPromise as T } from "./keys.es.js";
import { g as Q, a as X } from "./plugin-component-config-DXFKcbOi.js";
const to = /* @__PURE__ */ H({
  name: "drawing-manager",
  __name: "drawing-manager",
  props: {
    circleOptions: { default: void 0 },
    drawingControl: { type: Boolean, default: !0 },
    drawingControlOptions: { default: void 0 },
    drawingMode: { default: null },
    markerOptions: { default: void 0 },
    polygonOptions: { default: void 0 },
    polylineOptions: { default: void 0 },
    rectangleOptions: { default: void 0 },
    position: { default: void 0 },
    drawingModes: { default: void 0 },
    shapes: { default: void 0 },
    drawingKey: { default: void 0 },
    mapKey: { default: void 0 },
    options: { default: void 0 }
  },
  emits: ["circlecomplete", "markercomplete", "polygoncomplete", "polylinecomplete", "rectanglecomplete", "overlaycomplete", "update:shapes", "added:shape", "removed:shape"],
  setup(M, { expose: _, emit: h }) {
    var C, E, g, v;
    const n = M, l = h, f = I(), y = n.mapKey ? b(n.mapKey) : (E = (C = W("map-layer")) == null ? void 0 : C.exposed) == null ? void 0 : E.mapPromise;
    if (!y)
      throw new Error("The map promise was not built");
    const { promiseDeferred: u, promise: r } = Y(n.drawingKey ?? T);
    K(n.drawingKey ?? T, r);
    const R = (v = (g = j()) == null ? void 0 : g.excludeEventsOnAllComponents) == null ? void 0 : v.call(g);
    let d, t;
    y.then(async (o) => {
      var P;
      if (!o)
        throw new Error("the map instance is not defined");
      d = o;
      const e = {
        drawingModes: [
          google.maps.drawing.OverlayType.MARKER,
          google.maps.drawing.OverlayType.CIRCLE,
          google.maps.drawing.OverlayType.POLYGON,
          google.maps.drawing.OverlayType.POLYLINE,
          google.maps.drawing.OverlayType.RECTANGLE
        ],
        position: google.maps.ControlPosition.TOP_CENTER
      }, a = {
        map: o,
        ...z(n),
        ...n.options
      }, { DrawingManager: p } = await google.maps.importLibrary(
        "drawing"
      ), i = new p({
        ...a,
        drawingControlOptions: {
          ...e,
          ...a.drawingControlOptions
        },
        drawingControl: f.default ? !f.default : n.drawingControl
      }), D = Q("GmvDrawingManager"), k = X(
        "GmvDrawingManager",
        "auto"
      );
      if (V(
        D,
        i,
        l,
        n
      ), q(
        k,
        i,
        l,
        R
      ), i.addListener(
        "overlaycomplete",
        async (F) => {
          await B(F);
        }
      ), o.addListener("click", c), (P = n.shapes) != null && P.length && G(), !u.resolve)
        throw new Error("drawingPromiseDeferred.resolve is undefined");
      u.resolve(i);
    }).catch((o) => {
      throw o;
    });
    const L = x(() => {
      switch (n.position) {
        case "TOP_CENTER":
          return google.maps.ControlPosition.TOP_CENTER;
        case "TOP_LEFT":
          return google.maps.ControlPosition.TOP_LEFT;
        case "TOP_RIGHT":
          return google.maps.ControlPosition.TOP_RIGHT;
        case "BOTTOM_CENTER":
          return google.maps.ControlPosition.BOTTOM_CENTER;
        case "BOTTOM_LEFT":
          return google.maps.ControlPosition.BOTTOM_LEFT;
        case "BOTTOM_RIGHT":
          return google.maps.ControlPosition.BOTTOM_RIGHT;
        case "LEFT_BOTTOM":
          return google.maps.ControlPosition.LEFT_BOTTOM;
        case "LEFT_CENTER":
          return google.maps.ControlPosition.LEFT_CENTER;
        case "LEFT_TOP":
          return google.maps.ControlPosition.LEFT_TOP;
        case "RIGHT_BOTTOM":
          return google.maps.ControlPosition.RIGHT_BOTTOM;
        case "RIGHT_CENTER":
          return google.maps.ControlPosition.RIGHT_CENTER;
        case "RIGHT_TOP":
          return google.maps.ControlPosition.RIGHT_TOP;
        default:
          return google.maps.ControlPosition.TOP_CENTER;
      }
    }), G = () => {
      var o;
      (o = n.shapes) == null || o.forEach((e) => {
        if (!d)
          throw new Error("the map instance is not defined");
        e.overlay.setMap(d), google.maps.event.addListener(e.overlay, "click", () => {
          m(e);
        });
      });
    }, c = () => {
      t != null && t.overlay && (t.overlay.set("fillColor", "#777"), t.overlay.set("strokeColor", "#999"), t.overlay.setOptions({ editable: !1 }), t.overlay.setDraggable(!1), t = void 0);
    }, m = (o) => {
      c(), o.overlay.setOptions({ editable: !0 }), o.overlay.setDraggable(!0), t = o, t.overlay.set("fillColor", "#555"), t.overlay.set("strokeColor", "#777");
    }, B = async (o) => {
      var e;
      await O(null), l("added:shape", o), l("update:shapes", [
        ...(e = n.shapes) != null && e.length ? n.shapes : [],
        o
      ]), google.maps.event.addListener(o.overlay, "click", () => {
        m(o);
      }), google.maps.event.addListener(o.overlay, "rightclick", () => {
        w();
      }), m(o);
    }, O = async (o) => {
      const e = await r;
      if (!e) {
        console.error("the drawing manager is not defined");
        return;
      }
      e.setDrawingMode(o);
    }, w = () => {
      var o, e;
      if (t != null && t.overlay) {
        t.overlay.setMap(null);
        const a = (o = n.shapes) == null ? void 0 : o.indexOf(t);
        if (a && a >= 0) {
          const p = [...(e = n.shapes) != null && e.length ? n.shapes : []], [i] = p.splice(a, 1);
          i && l("removed:shape", i), l("update:shapes", p);
        }
      }
    }, N = () => {
      var o;
      c(), (o = n.shapes) == null || o.forEach((e) => {
        e.overlay.setMap(null);
      });
    };
    return s(
      () => n.drawingControlOptions,
      async (o, e) => {
        const a = await r;
        a && o && o !== e && a.setOptions({
          drawingControlOptions: { ...e, ...o }
        });
      }
    ), s(
      () => n.position,
      async (o, e) => {
        const a = await r;
        a && o && o !== e && a.setOptions({
          drawingControlOptions: { position: L.value }
        });
      }
    ), s(
      () => n.drawingModes,
      async (o, e) => {
        const a = await r;
        a && o && o !== e && a.setOptions({
          drawingControlOptions: { drawingModes: o }
        });
      }
    ), s(
      () => n.drawingControlOptions,
      async (o) => {
        const e = await r;
        e && o && e.setOptions({ drawingControlOptions: o });
      }
    ), s(
      () => n.circleOptions,
      async (o) => {
        const e = await r;
        e && o && e.setOptions({ circleOptions: o });
      }
    ), s(
      () => n.markerOptions,
      async (o) => {
        const e = await r;
        e && o && e.setOptions({ markerOptions: o });
      }
    ), s(
      () => n.polygonOptions,
      async (o) => {
        const e = await r;
        e && o && e.setOptions({ polygonOptions: o });
      }
    ), s(
      () => n.polylineOptions,
      async (o) => {
        const e = await r;
        e && o && e.setOptions({ polylineOptions: o });
      }
    ), s(
      () => n.rectangleOptions,
      async (o) => {
        const e = await r;
        e && o && e.setOptions({ rectangleOptions: o });
      }
    ), A(async () => {
      var o;
      (o = await r) == null || o.setMap(null), J(n.drawingKey ?? T);
    }), _({
      setDrawingMode: O,
      deleteSelection: w,
      clearAll: N,
      drawingManagerPromise: r
    }), (o, e) => (S(), $("div", null, [
      U(o.$slots, "default", {
        deleteSelection: w,
        setDrawingMode: O
      })
    ]));
  }
});
export {
  to as _
};
