import { defineComponent as U, useTemplateRef as H, provide as V, computed as g, watch as W, onMounted as F, onBeforeUnmount as j, onUnmounted as J, openBlock as N, createElementBlock as q, createElementVNode as B, renderSlot as z } from "vue";
import { H as Q, u as X, G as Y, p as ee, I as oe, A as te, z as ne, t as ae, J as se, a as re, L as b, v as ie } from "./resize-bus-BJO1V4ET.js";
import { $mapPromise as v, $recyclePrefix as de } from "./keys.es.js";
import { g as le, a as ce } from "./plugin-component-config-DXFKcbOi.js";
const pe = { class: "gmv-map-container" }, ue = {
  ref: "gmvMapRef",
  class: "gmv-map"
}, fe = { class: "gmv-map-hidden" };
var P, O, L;
const me = /* @__PURE__ */ U({
  name: "map-layer",
  __name: "map-layer",
  props: {
    backgroundColor: { default: void 0 },
    center: {},
    clickableIcons: { type: Boolean, default: !0 },
    controlSize: { default: void 0 },
    disableDefaultUI: { type: Boolean, default: !1 },
    disableDoubleClickZoom: { type: Boolean, default: void 0 },
    draggableCursor: { default: void 0 },
    draggingCursor: { default: void 0 },
    fullscreenControl: { type: Boolean, default: !0 },
    fullscreenControlOptions: { default: void 0 },
    gestureHandling: { default: "auto" },
    heading: { default: void 0 },
    isFractionalZoomEnabled: { type: Boolean, default: void 0 },
    keyboardShortcuts: { type: Boolean, default: !0 },
    mapId: { default: void 0 },
    mapTypeControl: { type: Boolean, default: !0 },
    mapTypeControlOptions: { default: void 0 },
    mapTypeId: { default: ((L = (O = (P = globalThis == null ? void 0 : globalThis.google) == null ? void 0 : P.maps) == null ? void 0 : O.MapTypeId) == null ? void 0 : L.ROADMAP) || "roadmap" },
    maxZoom: { default: void 0 },
    minZoom: { default: void 0 },
    noClear: { type: Boolean, default: void 0 },
    restriction: { default: void 0 },
    rotateControl: { type: Boolean, default: !0 },
    rotateControlOptions: { default: void 0 },
    scaleControl: { type: Boolean, default: !0 },
    scaleControlOptions: { default: void 0 },
    scrollwheel: { type: Boolean, default: void 0 },
    streetView: { default: void 0 },
    streetViewControl: { type: Boolean, default: !0 },
    streetViewControlOptions: { default: void 0 },
    styles: { default: void 0 },
    tilt: { default: void 0 },
    zoom: { default: void 0 },
    zoomControl: { type: Boolean, default: !0 },
    zoomControlOptions: { default: void 0 },
    mapKey: { default: void 0 },
    resizeBus: { default: void 0 },
    options: { default: void 0 }
  },
  emits: ["bounds_changed", "center_changed", "click", "contextmenu", "dblclick", "drag", "dragend", "dragstart", "heading_changed", "idle", "isfractionalzoomenabled_changed", "mapcapabilities_changed", "maptypeid_changed", "mousemove", "mouseout", "mouseover", "projection_changed", "renderingtype_changed", "tilesloaded", "tilt_changed", "zoom_changed", "resize"],
  setup(d, { expose: u, emit: l }) {
    var p, _;
    const t = d, r = H("gmvMapRef"), i = l;
    function c() {
      var e;
      return t.mapKey ? t.mapKey : (e = t.options) != null && e.recycle ? t.options.recycle : "";
    }
    function f() {
      return `${de}${c()}`;
    }
    const M = (_ = (p = Q()) == null ? void 0 : p.excludeEventsOnAllComponents) == null ? void 0 : _.call(p), { promiseDeferred: y, promise: s } = X(c() || v);
    V(c() || v, s);
    const { currentResizeBus: k, _delayedResizeCallback: I } = b(), { _resizeCallback: E } = b();
    async function T() {
      const e = await s;
      e && google.maps.event.trigger(e, "resize");
    }
    function h() {
      s.then((e) => {
        if (!e)
          return;
        const o = e.getCenter();
        google.maps.event.trigger(e, "resize"), o && e.setCenter(o);
      }).catch((e) => {
        console.error(e);
      });
    }
    const C = g(() => {
      if (!t.center) {
        console.warn("center is not defined");
        return;
      }
      return typeof t.center.lat == "function" ? t.center.lat() : t.center.lat;
    }), w = g(() => {
      if (!t.center) {
        console.warn("center is not defined");
        return;
      }
      return typeof t.center.lng == "function" ? t.center.lng() : t.center.lng;
    }), R = g(
      () => ({ lat: C.value, lng: w.value })
    );
    async function D(e, o) {
      const n = await s;
      n && n.panBy(e, o);
    }
    async function x(e) {
      const o = await s;
      o && o.panTo(e);
    }
    async function G(e, o) {
      const n = await s;
      n && n.panToBounds(e, o);
    }
    async function K(e, o) {
      const n = await s;
      n && n.fitBounds(e, o);
    }
    return W(
      () => t.zoom,
      async (e, o) => {
        const n = await s;
        n && e && e !== o && n.setZoom(e);
      }
    ), F(() => {
      var e;
      (e = Y()) == null || e.then(async () => {
        if (!r.value)
          throw new Error("we can find the template ref: 'gmvMap'");
        const o = {
          ...ee(t),
          ...t.options
        }, n = f();
        let a;
        if (window[n])
          r.value.appendChild(
            window[n].div
          ), a = window[n].map, a.setOptions(o);
        else {
          const { Map: m } = await google.maps.importLibrary(
            "maps"
          );
          a = new m(r.value, o), window[n] = { map: a };
        }
        oe(t, h);
        const S = le("GmvMap"), A = ce("GmvMap", "auto");
        if (te(
          S,
          a,
          i,
          t
        ), ne(
          A,
          a,
          i,
          M
        ), ae(
          (m, Z, $) => {
            a.addListener("center_changed", () => {
              $() && i("center_changed", a.getCenter()), Z();
            }), ie(
              ["finalLat", "finalLng"],
              () => {
                m(), a.setCenter(R.value);
              },
              { finalLat: C, finalLng: w }
            );
          }
        ), a.addListener("zoom_changed", () => {
          i("zoom_changed", a.getZoom());
        }), a.addListener("bounds_changed", () => {
          i("bounds_changed", a.getBounds());
        }), !y.resolve)
          throw new Error("mapPromiseDeferred.resolve is undefined");
        y.resolve(a);
      }).catch((o) => {
        throw o;
      });
    }), j(async () => {
      const e = await s;
      if (e) {
        const o = f();
        window[o] && (window[o].div = e.getDiv());
      }
    }), J(() => {
      se(), re(c() || v);
    }), u({
      mapPromise: s,
      panBy: D,
      panTo: x,
      panToBounds: G,
      fitBounds: K,
      currentResizeBus: k,
      _resizeCallback: E,
      _delayedResizeCallback: I,
      resize: T,
      resizePreserveCenter: h,
      getRecycleKey: f
    }), (e, o) => (N(), q("div", pe, [
      B("div", ue, null, 512),
      B("div", fe, [
        z(e.$slots, "default", {}, void 0, !0)
      ]),
      z(e.$slots, "visible", {}, void 0, !0)
    ]));
  }
}), ge = (d, u) => {
  const l = d.__vccOpts || d;
  for (const [t, r] of u)
    l[t] = r;
  return l;
}, _e = /* @__PURE__ */ ge(me, [["__scopeId", "data-v-bad72917"]]);
export {
  _e as default
};
