import { defineComponent as D, useTemplateRef as R, provide as T, computed as p, watch as c, onMounted as M, onUnmounted as x, openBlock as A, createElementBlock as K, createElementVNode as W, renderSlot as U } from "vue";
import { H as Z, u as $, M as d, G as q, p as F, A as H, z as I, t as N, a as j, L as P, v as J } from "./resize-bus-BJO1V4ET.js";
import { $streetViewPanoramaPromise as m } from "./keys.es.js";
import { g as Q, a as X } from "./plugin-component-config-DXFKcbOi.js";
const Y = { class: "gmv-street-view-panorama-container" }, ee = {
  ref: "gmvStreetViewPanoramaRef",
  class: "gmv-street-view-panorama"
}, ie = /* @__PURE__ */ D({
  name: "street-view-panorama",
  __name: "street-view-panorama",
  props: {
    addressControl: { type: Boolean },
    addressControlOptions: { default: void 0 },
    clickToGo: { type: Boolean, default: !0 },
    controlSize: { default: void 0 },
    disableDefaultUI: { type: Boolean },
    disableDoubleClickZoom: { type: Boolean, default: !0 },
    enableCloseButton: { type: Boolean, default: !1 },
    fullscreenControl: { type: Boolean },
    fullscreenControlOptions: { default: void 0 },
    imageDateControl: { type: Boolean },
    linksControl: { type: Boolean },
    motionTracking: { type: Boolean },
    motionTrackingControl: { type: Boolean },
    motionTrackingControlOptions: { default: void 0 },
    panControl: { type: Boolean },
    panControlOptions: { default: void 0 },
    pano: { default: void 0 },
    position: { default: void 0 },
    pov: { default: void 0 },
    scrollwheel: { type: Boolean, default: !0 },
    showRoadLabels: { type: Boolean, default: !0 },
    visible: { type: Boolean, default: !0 },
    zoom: { default: void 0 },
    zoomControl: { type: Boolean },
    zoomControlOptions: { default: void 0 },
    streetViewKey: { default: void 0 },
    options: { default: void 0 }
  },
  emits: ["closeclick", "pano_changed", "position_changed", "pov_changed", "resize", "status_changed", "visible_changed", "zoom_changed"],
  setup(y, { expose: h, emit: C }) {
    var i, w;
    const o = y, r = R(
      "gmvStreetViewPanoramaRef"
    ), l = C, V = (w = (i = Z()) == null ? void 0 : i.excludeEventsOnAllComponents) == null ? void 0 : w.call(i), { promiseDeferred: f, promise: s } = $(o.streetViewKey ?? m);
    T(o.streetViewKey ?? m, s);
    const { currentResizeBus: B, _delayedResizeCallback: _ } = P(), { _resizeCallback: z } = P();
    async function E() {
      const e = await s;
      e && google.maps.event.trigger(e, "resize");
    }
    async function O() {
      const e = await s;
      if (!e)
        return;
      const t = e.getPosition();
      google.maps.event.trigger(e, "resize"), t && e.setPosition(t);
    }
    const u = p(() => {
      if (!o.position) {
        console.warn("position is not defined");
        return;
      }
      return typeof o.position.lat == "function" ? o.position.lat() : o.position.lat;
    }), v = p(() => {
      if (!o.position) {
        console.warn("position is not defined");
        return;
      }
      return typeof o.position.lng == "function" ? o.position.lng() : o.position.lng;
    }), S = p(
      () => ({ lat: u.value, lng: v.value })
    );
    return c(
      () => o.zoom,
      async (e, t) => {
        const n = await s;
        n && e && !d(e, t) && n.setZoom(e);
      }
    ), c(
      () => o.pov,
      async (e, t) => {
        const n = await s;
        n && e && !d(e, t) && n.setPov(e);
      }
    ), c(
      () => o.pano,
      async (e, t) => {
        const n = await s;
        n && e && !d(e, t) && n.setPano(e);
      }
    ), M(() => {
      var e;
      (e = q()) == null || e.then(async () => {
        if (!r.value)
          throw new Error(
            "we can find the template ref: 'gmvStreetViewPanorama'"
          );
        const t = {
          ...F(o),
          ...o.options
        }, { StreetViewPanorama: n } = await google.maps.importLibrary(
          "streetView"
        ), a = new n(
          r.value,
          t
        ), b = Q(
          "GmvStreetViewPanorama"
        ), k = X(
          "GmvStreetViewPanorama",
          "auto"
        );
        if (H(
          b,
          a,
          l,
          o
        ), I(
          k,
          a,
          l,
          V
        ), N((g, L, G) => {
          if (g(), !a)
            throw new Error("the street view panorama instance was not created");
          a.addListener("position_changed", () => {
            if (G()) {
              if (!a)
                throw new Error(
                  "the street view panorama instance was not created"
                );
              l("position_changed", a.getPosition());
            }
            L();
          }), J(
            ["finalLat", "finalLng"],
            () => {
              if (g(), !a)
                throw new Error(
                  "the street view panorama instance was not created"
                );
              a.setPosition(S.value);
            },
            { finalLat: u, finalLng: v }
          );
        }), !f.resolve)
          throw new Error(
            "streetViewPanoramaPromiseDeferred.resolve is undefined"
          );
        f.resolve(a);
      }).catch((t) => {
        throw t;
      });
    }), x(() => {
      j(
        o.streetViewKey ?? m
      );
    }), h({
      currentResizeBus: B,
      _resizeCallback: z,
      _delayedResizeCallback: _,
      resize: E,
      resizePreserveCenter: O,
      streetViewPanoramaPromise: s,
      gmvStreetViewPanorama: r
    }), (e, t) => (A(), K("div", Y, [
      W("div", ee, null, 512),
      U(e.$slots, "default")
    ]));
  }
});
export {
  ie as _
};
