import { MarkerClusterer } from '@googlemaps/markerclusterer';
import { InjectionKey } from 'vue';
/**
 * This function returns a promise, when it is resolved returns the Google Maps component instance
 *
 * @param  {string} key - the recycle prop of the map
 * @returns {Promise}
 * @public
 */
export declare function useAutocompletePromise(key?: string | InjectionKey<Promise<google.maps.places.Autocomplete | undefined>>): Promise<google.maps.places.Autocomplete | undefined>;
/**
 * This function returns a promise, when it is resolved returns the Google Maps component instance
 *
 * @param  {string} key - the recycle prop of the map
 * @returns {Promise}
 * @public
 */
export declare function useMapPromise(key?: string | InjectionKey<Promise<google.maps.Map | undefined>>): Promise<google.maps.Map | undefined>;
/**
 * This function returns a promise, when it is resolved returns the Google Advanced Marker Element component instance
 *
 * @param  {string} key - the markerKey prop of the marker
 * @returns {Promise}
 * @public
 */
export declare function useMarkerPromise(key?: string | InjectionKey<Promise<google.maps.marker.AdvancedMarkerElement | undefined>>): Promise<google.maps.marker.AdvancedMarkerElement | undefined>;
/**
 * This function returns a promise, when it is resolved returns the Google Circle component instance
 *
 * @param  {string} key - the circleKey prop of the CircleShape
 * @returns {Promise}
 * @public
 */
export declare function useCirclePromise(key?: string | InjectionKey<Promise<google.maps.Circle | undefined>>): Promise<google.maps.Circle | undefined>;
/**
 * This function returns a promise, when it is resolved returns the Cluster component instance
 *
 * @param  {string} key - the clusterKey prop of the Cluster
 * @returns {Promise}
 * @public
 */
export declare function useClusterPromise(key?: string | InjectionKey<Promise<MarkerClusterer | undefined>>): Promise<MarkerClusterer | undefined>;
/**
 * This function returns a promise, when it is resolved returns the Google Map Drawing Manager component instance
 *
 * @param  {string} key - the drawingKey prop of the DrawingManager
 * @returns {Promise}
 * @public
 */
export declare function useDrawingPromise(key?: string | InjectionKey<Promise<google.maps.drawing.DrawingManager | undefined>>): Promise<google.maps.drawing.DrawingManager | undefined>;
/**
 * This function returns a promise, when it is resolved returns the Google Map Heatmap Layer component instance
 *
 * @param  {string} key - the heatmapKey prop of the Heatmap Layer
 * @returns {Promise}
 * @public
 */
export declare function useHeatmapLayerPromise(key?: string | InjectionKey<Promise<google.maps.visualization.HeatmapLayer | undefined>>): Promise<google.maps.visualization.HeatmapLayer | undefined>;
/**
 * This function returns a promise, when it is resolved returns the Google Map Info Window component instance
 *
 * @param  {string} key - the infoWindowKey prop of the Info Window
 * @returns {Promise}
 * @public
 */
export declare function useInfoWindowPromise(key?: string | InjectionKey<Promise<google.maps.InfoWindow | undefined>>): Promise<google.maps.InfoWindow | undefined>;
/**
 * This function returns a promise, when it is resolved returns the Google Map Kml Layer component instance
 *
 * @param  {string} key - the kmlKey prop of the Kml Layer
 * @returns {Promise}
 * @public
 */
export declare function useKmlPromise(key?: string | InjectionKey<Promise<google.maps.KmlLayer | undefined>>): Promise<google.maps.KmlLayer | undefined>;
/**
 * This function returns a promise, when it is resolved returns the Google Map Polygon component instance
 *
 * @param  {string} key - the polygonKey prop of the Polygon
 * @returns {Promise}
 * @public
 */
export declare function usePolygonPromise(key?: string | InjectionKey<Promise<google.maps.Polygon | undefined>>): Promise<google.maps.Polygon | undefined>;
/**
 * This function returns a promise, when it is resolved returns the Google Map Polyline component instance
 *
 * @param  {string} key - the polylineKey prop of the Polyline
 * @returns {Promise}
 * @public
 */
export declare function usePolylinePromise(key?: string | InjectionKey<Promise<google.maps.Polyline | undefined>>): Promise<google.maps.Polyline | undefined>;
/**
 * This function returns a promise, when it is resolved returns the Google Map Rectangle component instance
 *
 * @param  {string} key - the rectangleKey prop of the Rectangle
 * @returns {Promise}
 * @public
 */
export declare function useRectanglePromise(key?: string | InjectionKey<Promise<google.maps.Rectangle | undefined>>): Promise<google.maps.Rectangle | undefined>;
/**
 * This function returns a promise, when it is resolved returns the Google Map StreetViewPanorama component instance
 *
 * @param  {string} key - the streetViewKey prop of the StreetViewPanorama
 * @returns {Promise}
 * @public
 */
export declare function useStreetViewPanoramaPromise(key?: string | InjectionKey<Promise<google.maps.StreetViewPanorama | undefined>>): Promise<google.maps.StreetViewPanorama | undefined>;
