import { Emitter, EventType } from 'mitt';
/**
 * @typedef ResizeBus
 * @property {() => void} currentResizeBus
 * @property {() => void} _resizeCallback
 * @property {() => void} _delayedResizeCallback
 */
/**
 * this function returns the rezise bus functions
 *
 * @public
 * @returns {ResizeBus}
 */
export declare function useResizeBus(): {
    currentResizeBus: import('vue').Ref<Emitter<Record<EventType, unknown>> | undefined, Emitter<Record<EventType, unknown>> | undefined>;
    _resizeCallback: () => void;
    _delayedResizeCallback: () => void;
};
